import static org.junit.Assert.*;
import org.junit.Test;

/**
 * Abstract test cases for exponentiation, reusable for implementations.
 * Note that these test cases are not applied to AbstractPowerClass,
 * because it is not named AbstractPowerClassTest.
 * 
 * @author Tom Verhoeff (TU/e)
 */
public class AbstractPowerClassTestCases {
    
    /** Implementation under test.  Set by concrete test class. */
    protected AbstractPowerClass instance;
    
    public AbstractPowerClassTestCases() {
    }

    /**
     * Test of power method, of class AbstractPowerClass.
     */
    @Test
    public void testPowerZero() {
        System.out.println("power(1, 0)");
        int a = 1;
        int b = 0;
        int expResult = 1;
        long result = instance.power(a, b);
        assertEquals(expResult, result);
    }

    /**
     * Test of power method, of class AbstractPowerClass.
     */
    @Test
    public void testPowerOne() {
        System.out.println("power(2, 1)");
        int a = 2;
        int b = 1;
        int expResult = 2;
        long result = instance.power(a, b);
        assertEquals(expResult, result);
    }

    /**
     * Test of power method, of class AbstractPowerClass.
     */
    @Test
    public void testPowerTwo() {
        System.out.println("power(3, 2)");
        int a = 3;
        int b = 2;
        int expResult = 9;
        long result = instance.power(a, b);
        assertEquals(expResult, result);
    }

}
